(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(*
 * faudra trouver un super entte pour mettre sur nos fichiers
 *
 *
 *)

(* Blocker : un objet bloquant dans toutes les directions, 
 * pour tous les objets 
 *)

open Objet
open Position

class virtual ['kind, 'world, 'coerce] blocker world pos = 
object (self)
  (* un bloqueur est un objet... *)
  inherit ['kind, 'world, 'coerce] objet [] world pos as parent
    
  (* objet de type `mushroom *)
  method kind: 'kind = `Blocker

  (* tout le monde est bloqu *)
  method is_valid (obj: 'coerce) (dir: dir_t) = false

  (* affichage (mode texte) *)
  method print = print_char '#'
    
end
