(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(*
 * faudra trouver un super entte pour mettre sur nos fichiers
 *
 *
 *)

(* Walking : dfinition de la classe virtuelle 'walking' 
 *    qui permet, par hritage, d'avoir la capacit de 
 *    dplacement (direction, walk, left, right...)
 *)

open Position

class virtual walking =
object (self)

  (* la direction courante *)
  val mutable dir: dir_t = d_u (* Up au dpart*)
  method dir = dir
  method set_dir dir' = dir <- dir'

  (* changements de direction *)
  method left  = dir <- left  dir
  method right = dir <- right dir
  method back  = dir <- back  dir

  (* marche ! *)
  method walk: unit = self#move dir

  (* changements de direction avec dplacement *)
  method walk_left  = dir <- left  dir; self#walk
  method walk_right = dir <- right dir; self#walk

  (* affichage (mode texte) *)
  method w_print = print_char_dir self#dir;

end
