(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)

(* Debog : fonctions de debuguage *)

let always    = ([Obj.magic `Always] :  unit list)
let debugging = ref always 

let add   x = debugging := ((Obj.magic x) :: !debugging)
let clear() = debugging := always

let print_flush n s = 
  if List.mem (Obj.magic n) !debugging then 
    (print_string s; flush stdout)

let printf n = fun _ -> ()
(* Printf.kprintf (print_flush n) *)

(*  Printf.kprintf inconnu au bataillon dans Ocaml 3.04 *)
(*   suivre                                            *)

