(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)

(* Debog : fonctions de debuguage *)

(* ajout d'un nouveau type de dbogage *)
val add   : 'a -> unit

(* aucun dbogage *)
val clear : unit -> unit

(* dbogage d'un certain type *)
val printf: 'a -> ('b, unit, string) format -> unit


(* Exemple d'utilisation *)
(*
  Debog.add `Toto

  Debog.printf `Toto   "toto %d\n" 51    (* affich     *)
  Debog.printf `Titi   "titi %d\n" 33    (* non-affich *)
  Debog.printf `Always "tutu %d\n" 1664  (* affich     *)
*)
