(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(***************************)
(* dmo openGL / Glut / Tk *)
(***************************)

(* 
   portage ocaml de la librairie GLM

   cette librairie permet de lire/crire/dessiner des objets
   au format WaveFront (.obj)
*)

(* exception leve si la lecture d'un objet  partir d'un *)
(* fichier choue *)
exception ReadOBJ

(* options de dessin *)
type options = [ 
| `color  
| `flat
| `material
| `none 
| `smooth 
| `texture
] list

(* type abstrait reprsentant un modle *)
type model

(* le fichier "glm.h" documente trs prcisemment toutes ces fonctions *)

external unitize :          model -> float           = "ml_Unitize"
external dimensions :       model -> float array     = "ml_Dimensions"
external scale :            model -> float -> unit   = "ml_Scale"
external reverseWinding :   model -> unit            = "ml_ReverseWinding"
external facetNormals :     model -> unit            = "ml_FacetNormals"
external linearTexture :    model -> unit            = "ml_LinearTexture"
external spheremapTexture : model -> unit            = "ml_SpheremapTexture"
external delete :           model -> unit            = "ml_Delete"
external writeOBJ :         model -> string -> options -> unit = "ml_WriteOBJ"
external draw :             model -> options -> unit = "ml_Draw"
external weld :             model -> float -> unit   = "ml_Weld"

(* external vertexNormals_ : model -> float -> unit = "ml_VertexNormals" *)
val vertexNormals :         ?angle:float -> model -> unit

(* external readOBJ_ : string -> model = "ml_ReadOBJ" *)
val readOBJ :               string -> model
