/*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */
/***************************/
/* dmo openGL / Glut / Tk */
/***************************/

/* 
   slection d'objets  la souris 
*/


#include <GL/gl.h>
#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/misc.h>
#include <caml/alloc.h>
    
#define BUFSIZE 512
GLuint selectBuf[BUFSIZE];


CAMLprim value ml_Init(value unit) {
  CAMLparam1(unit);
  (void)glSelectBuffer(BUFSIZE, selectBuf);
  CAMLreturn(Val_unit);
}

CAMLprim value ml_Begin(value unit) {
  CAMLparam1(unit);
  /* mode d'affichage 'select' */
  (void)glRenderMode(GL_SELECT);
  CAMLreturn(Val_unit);
}

int end ()
{
   unsigned int i, j;
   GLuint names, *ptr, minZ,*ptrNames=NULL;
   GLint hits;

   /* mode d'affichage normal : 'render' */
   hits = glRenderMode(GL_RENDER);
   
   /* on rcupre l'objet le plus proche */
   ptr = (GLuint *) selectBuf;
   minZ = 0xffffffff;
   for (i = 0; i < hits; i++) {	
      names = *ptr;
	  ptr++;
	  if (*ptr < minZ) {
		  minZ = *ptr;
		  ptrNames = ptr+2;
	  }
	  
	  ptr += names+2;
	}

  return ptrNames? *ptrNames : -1;
}

    
CAMLprim value ml_End(value unit) {
  CAMLparam1(unit);
  CAMLlocal1(ret);
  ret = Val_int(end());
  CAMLreturn(ret);
}
    

