/*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

/* 
 * textures.h: helper functions for managing textures from OCAML/LABLGL.
 * This provides routines to load in a mipmap texture from a PPM image on disk
 * (returning an id), to bind a loaded texture, and to destroy a texture.
 */

#include <GL/gl.h>
#include <GL/glu.h>
#include <jpeglib.h>

typedef struct tImageJPG
{
	int rowSpan;
	int sizeX;
	int sizeY;
	unsigned char *data;
}tImageJPG;

GLubyte *readPPM (const char *fname, GLint *glw, GLint *glh);
GLubyte *readBMP (const char *File, GLint *Width, GLint *Height,GLint *c,GLenum *f,GLenum *t);
void   DecodeJPG(struct jpeg_decompress_struct *cinfo, tImageJPG *pImageData);
GLubyte *readJPG(const char *filename, GLint *glw, GLint *glh);
