(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(*
 * faudra trouver un super entte pour mettre sur nos fichiers
 *
 *
 *)

(* Gl_base : dfinition des types de classe gl_cell_t, gl_world_t et gl_objet_t *)

(* open Gl_position *)
open Objet
open World
open Cell


(* type de la classe des objets dessinables *)
class type gl_drawable = 
object
  method gl_draw: unit
end


(* dfinition d'un monde *)
class type ['obj] gl_world_t = 
object
  inherit ['obj] world_t
  inherit gl_drawable
end



(* dfinition d'un objet du monde *)
and ['kind, 'world] gl_objet_t = 
object
  inherit ['kind, 'world, ('kind, 'world) gl_objet_t] objet_t
  inherit gl_drawable
end

