(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(*
 * faudra trouver un super entte pour mettre sur nos fichiers
 *
 *
 *)

(* Gl_bridge : dfinition de la classe _relle_ 'gl_bridge' *)

open Bridge
open Gl_base
open Gl_objet

class ['kind , 'world] gl_bridge orient world pos =
object

  (* un gl_bridge est un bridge qui peut se coercer en 'gl_objet_t' *)
  inherit ['kind , 'world, ('kind, 'world) gl_objet_t] bridge orient world pos

  (* c'est aussi un gl_objet *)
  inherit ['kind , 'world] gl_objet  

  (* dessin du champignon *)
  method gl_draw =
    (* TODO (3d) *)
    print_string "GL: I'm a bridge ;-)";
    print_newline()
end

let create = new gl_bridge
