(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
type roption_t = [`Texture]
type doption_t = [`Grid|`LimitRayon]

type patern_t = bool array array

type look_t = int

class type t=
object  
  method init                  : int -> float -> unit

  method get_dim               : unit -> int*int
  method get_squareDim         : unit -> float*float

  method draw_all              : unit -> unit
  method draw                  : (int*int) -> (float*float) -> unit
  method draw_ext              : (int*int) -> (float*float) -> patern_t -> unit

  method get_z                 : (float*float) -> float

  method enable_roption        : roption_t -> unit
  method disable_roption       : roption_t -> unit

  method enable_doption        : doption_t -> unit
  method disable_doption       : doption_t -> unit
end

class glMap3d : HeightField.t->look_t->t

val glMap3d_from_file : string->t

