(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
type t 

type relief_t = 
    Hill of float*float
      (* hauteur pente *)
  | Plateau of float*float*(int*int)
      (* hauteur pente dimension *)
  | Valley of float*float*(int*int)
      (* profondeur pente dimension *)
  | Lack of float*float
      (* profondeur pente *)

val heightField_of_floatMatrix : float array array -> t
val load_bmpHeight : string -> t
val gen_height : int -> int -> t
val get_dimX : t -> int
val get_dimY : t -> int
val get : t -> (int*int) -> float

val put_relief : t -> relief_t -> int*int -> t
