(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(*
 * faudra trouver un super entte pour mettre sur nos fichiers
 *
 *
 *)
(* Gl_decor : dfinition de la classe relle 'gl_decor' *)


open Gml

let mode=[`smooth;`texture;`material]
class  gl_decor file =
object(self)

  val mutable rot = 0.
  val mutable step =0.5


  val list=
    let o=Gml.readOBJ file in
    Printf.printf "scale factor :%f\n" (Gml.unitize o);
    Gml.facetNormals o;
    Gml.vertexNormals o;
    o
     
  method gl_draw =
    GlMat.push();
    GlDraw.color  (1.0,1.0,1.0);
    rot<-rot;
    GlMat.rotate3 rot (0., 1., 0.);
    Gml.draw list  mode;
  
  method incR=
    step <- step +. 0.5
  method decR=
    step <- step -. 0.5
      
end

let create = new gl_decor

