(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(*
 * faudra trouver un super entte pour mettre sur nos fichiers
 *
 *
 *)

(* Main : le programme principal *)
open Gl_main;;

let main () =

  
  flush stdout;
  let top  = Window.create() in
    
  (* Cration du widget OpenGL *)
  let togl = Togl.create top 
	       ~rgba:true 
	       ~depth:true 
	       ~double:true 
  in
    Window.pack top togl;
  let file =match Sys.argv with [|a;b|]->b|_->"" in

  let z = new gl_main togl file   in


  let onTimer () =
    Togl.render togl
  in

 
  Togl.reshape_func  togl ~cb:z#onReshape;
  Togl.display_func  togl ~cb:z#onDisplay;
  Togl.timer_func ~ms:1   ~cb:onTimer;
  Tk.bind top
    ~events:[`KeyPress] 
    ~fields:[`KeySymString] 
    ~action:(fun ev -> z#onKeyPress ev.Tk.ev_KeySymString);
  
  Tk.mainLoop()

;;

main() 
