(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(***************************)
(* dmo openGL / Glut / Tk *)
(***************************)

(* gestion de la fentre Tk *)

open Tk

(* cration de la fentre *)
let create () =
  let top = openTk() in
    Wm.aspect_set top ~minnum:4 ~mindenom:3 ~maxnum:4 ~maxdenom:3;
    Wm.title_set top "OCaml with openGL/Glut/Tk demo";
  
  top


(* cration des menus/bouttons, "enpaquetage" de la fentre *)
let pack top togl =
  let menubar  = Frame.create 
		   ~borderwidth:1
		   ~relief:`Raised 
		   top 
  in 
  let fileb    = Menubutton.create 
		   ~text:"File" 
		   ~borderwidth:1
		   menubar 
  in 
  let filemenu = Menu.create 
		   ~tearoff:false 
		   ~borderwidth:1
		   fileb 
  in
  let mkbutt (text,handler) =
    let butt = Button.create ~text ~borderwidth:1 menubar in
      bind butt
	~events:[`ButtonRelease] 
	~action:(fun _ -> handler());
      butt
  in

    Menu.add_command filemenu 
      ~label:"Quitter" 
      ~command:(fun () -> Tk.destroy top; exit 0);
    Menubutton.configure 
      fileb 
      ~menu:filemenu;

    pack 
      ~fill:`Both 
      ~side:`Bottom 
      ~expand:true 
      [togl];

    pack 
      ~side:`Left 
      [fileb];
  (*    
    pack 
      ~side:`Left 
      (List.map mkbutt [
	">", (fun () -> Camera.step_phi  (-0.5)) ;
	"<", (fun () -> Camera.step_phi  ( 0.5)) ;
	"^", (fun () -> Camera.step_teta (-0.5)) ;
	"v", (fun () -> Camera.step_teta ( 0.5)) ;
	"+", (fun () -> Camera.step_r    (-1. )) ;
	"-", (fun () -> Camera.step_r    ( 1. )) ;
	"light0", (fun () -> Camera.switch 0; Togl.render togl) ;
	"light1", (fun () -> Camera.switch 1; Togl.render togl) ;
	"light2", (fun () -> Camera.switch 2; Togl.render togl) ;
      ]);
*)
    place 
      ~height:32 
      ~x:0 
      ~y:0 
      ~relwidth:1.0 
      menubar;
    


