(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)



class gl_node id =
  object(self)

    val mutable i=id
	
    val mutable child = []
    val mutable rot_x = 0.
    val mutable rot_y = 0.
    val mutable rot_z = 0.

    val mutable pos_x = 0.
    val mutable pos_y = 0.
    val mutable pos_z = 0.

    method setPos tx ty tz=
      pos_z<-tx;
      pos_y<-ty;
      pos_x<-tz
    method rotX a =
      rot_x <-  a
    method rotY a =
      rot_y <-  a
    method rotZ a =
      rot_z <-  a

    method drawAll =
 
      GlMat.push();
      
      GlMat.translate3 (pos_x,pos_y,pos_z);
      GlMat.rotate3 rot_x (1.0,0.0,0.0);
      GlMat.rotate3 rot_y (0.0,1.0,0.0);
      GlMat.rotate3 rot_z (0.0,0.0,1.0);
      

      self#draw;
      
      List.iter (fun o -> o#drawAll) child;
      
      GlMat.pop();

    method draw=
      GlMat.push();
      
      GlDraw.color  (1.0,0.0,1.0);
      Glut.solidCube ~size:0.3;
      
      GlMat.pop();

    method addChild (a:gl_node) = 
      child <- a::child
end

