(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(*
 * faudra trouver un super entte pour mettre sur nos fichiers
 *
 *
 *)

(* Gl_robot : dfinition de la classe relle 'gl_robot' *)



open Gl_node


class gl_robot world cam=
  object(self)
   
    val mutable camera = cam
    val mutable head=new gl_node 1
    val mutable neck=new gl_node 2
    val mutable body=new gl_node 3
    val mutable arml=new gl_node 4
    val mutable armr=new gl_node 5
    val mutable legl=new gl_node 6
    val mutable legr=new gl_node 7
    val mutable ll_1=new gl_node 12
    val mutable ll_2=new gl_node 13
    val mutable rl_1=new gl_node 14
    val mutable rl_2=new gl_node 15
    val mutable la_1=new gl_node 8
    val mutable la_2=new gl_node 9
    val mutable ra_1=new gl_node 10
    val mutable ra_2=new gl_node 11
    val mutable di = true
    val mutable b = (0.)
    val mutable c = 0.
    val mutable etat = 0
    val mutable posx= 0.
    val mutable posy= 0.
    val mutable posz= 0.

    method marchea =
      arml#rotZ(b*.1.2);
      armr#rotZ(c*.1.2);
      legr#rotZ (b+.10.);
      legl#rotZ (c+.10.);
      posx<-posx+.0.05;
      if di then 
	(b<-b+.4.;c<-c-.4.)
       
      else  
	(b<-b-.4.;c<-c+.4.)
       ;
      if (b>40.) then (
	b<-40.;
	c<- (-40.);
	if di then (di<-false) else (di<-true) 
       );
      if (b<(-40.)) then (
	c<-40.;
	b<-(-40.);
	if di then (di<-false )else di<-true;);
      if (b< 0.)then( ll_1#rotZ (b);ll_2#rotZ((b)));
      if (c< 0.)then( rl_1#rotZ (c);rl_2#rotZ((c)));
      neck#rotZ (b/.5.);
      neck#rotY (b/.5.);
      neck#rotX (-.b/.5.);
      la_1#rotZ(b);
      ra_1#rotZ(-.b);
      if(b= 0.) then etat<-0


   method reculea =
      arml#rotZ(b*.1.2);
      armr#rotZ(c*.1.2);
      legr#rotZ (b+.10.);
      legl#rotZ (c+.10.);
      posx<-posx-.0.05;
      if di then 
	(b<-b-.4.;c<-c+.4.)
       
      else  
	(b<-b+.4.;c<-c-.4.)
       ;
      if (b>40.) then (
	b<-40.;
	c<- (-40.);
	if di then (di<-false) else (di<-true) 
       );
      if (b<(-40.)) then (
	c<-40.;
	b<-(-40.);
	if di then (di<-false )else di<-true;);
      if (b< 0.)then( ll_1#rotZ (b);ll_2#rotZ((b)));
      if (c< 0.)then( rl_1#rotZ (c);rl_2#rotZ((c)));
      neck#rotZ (b/.5.);
      neck#rotY (b/.5.);
      neck#rotX (-.b/.5.);
      la_1#rotZ(b);
      ra_1#rotZ(-.b);
      if(b= 0.) then etat<-0


    method get_x =
      posx
    method get_y =
      posy
    method get_z =
      posz

    method set_y h=
      posy<-h

    method movea =
      match etat with
      | 1-> self#marchea;
      | 2-> self#reculea;
      | _->()
     
	  


    method gl_draw =
      
      GlMat.push();
      GlMat.translate3 (posx,posy,posz); 

      self#movea;
      GlMat.scale ~x:0.2 ~y:0.2 ~z:0.2;
      body#drawAll;
      GlMat.pop();
      GlMat.pop()

    method r_leg a =  legl#rotZ a
      

    method avance  =
      etat<-1
    method recule  =
      etat<-2
	  
    initializer

      neck#addChild(head);
      body#addChild(neck);
      body#addChild(arml);
      body#addChild(armr);
      body#addChild(legl);
      body#addChild(legr);

      arml#addChild(la_1);
      la_1#addChild(la_2);
      armr#addChild(ra_1);
      ra_1#addChild(ra_2);

      legl#addChild(ll_1);
      ll_1#addChild(ll_2);
      legr#addChild(rl_1);
      rl_1#addChild(rl_2);

      body#setPos 2.0 (2.0) 2.0;
      head#setPos 0.0 0.5 0.0 ;
      neck#setPos 0.0 1.0 0.0 ;
      arml#setPos (-0.5) 1.0 0.0 ;
      armr#setPos 0.5 1.0 0.0 ;
      legl#setPos (-0.30) (-.0.5) 0.0 ;
      legr#setPos 0.30 (-.0.5) 0.0 ;
      ll_1#setPos 0.0 (-.0.5) 0.0 ;
      ll_2#setPos 0.0 (-.0.5) 0.0 ;
      rl_1#setPos 0.0 (-.0.5) 0.0 ;
      rl_2#setPos 0.0 (-.0.5) 0.0 ;
      la_1#setPos 0.0 (-.0.5) 0.0 ;
      la_2#setPos 0.0 (-.0.5) 0.0 ;
      ra_1#setPos 0.0 (-.0.5) 0.0 ;
      ra_2#setPos 0.0 (-.0.5) 0.0 ;

end
    
let create = new gl_robot




