(*
 *
 * Copyright (C) 2002 Aurelien Moreau, Antoni Gutsens Diaz, Benjamin Leveque,
 * 	 Damien Pous, David Roger, Lionel Vaux, Mathieu Martin, Nicolas Bernard,
 * 	 Samuel Thibault, Simon Capern, Thomas Gazagnaire
 * 
 * This file is part of Rigobot.
 * 
 * Rigobot is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Ribogot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ribogot; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *)
(*
 * faudra trouver un super entte pour mettre sur nos fichiers
 *
 *
 *)

(* Gl_world : un monde reprsent dans le monde 3d *)

open Textures
open GlMap3d

class gl_world =
object (self)

  val glMapObj   =GlMap3d.glMap3d_from_file "land.bmp"

 
  val texsky = Textures.loadJPG "Top.jpg" 


  method glMapObj=
    glMapObj


  method draw_sky=
    Gl.enable `texture_2d;
    GlTex.env (`mode `modulate);
    Textures.bind texsky;
    GlMat.push();
    GlMat.translate3 (0.0,25.,0.);
    GlDraw.begins `quads;
    GlDraw.color  (1.0,1.0,1.0);
    GlTex.coord2 (0., 0.);
    GlDraw.vertex3( -100.0, 0.0, -100.0 );
    GlTex.coord2 (1., 0.);
    GlDraw.vertex3( 100.0, 0.0, -100.0 );
    GlTex.coord2 (1., 1.);
    GlDraw.vertex3( 100.0, 0.0, 100.0) ;
    GlTex.coord2 (0., 1.);
    GlDraw.vertex3( -100.0, 0.0, 100.0) ;
    GlDraw.ends ();
    GlMat.pop();
    Gl.disable `texture_2d

  method gl_draw =
    Gl.disable `fog;
    GlMat.push();
    self#draw_sky;
    GlMat.pop();

    GlMat.push();
    (*GlMat.translate3 (0.0,-10.,0.);*)
    GlMat.rotate3 (-90.) (1.0,0.,0.);
    GlMat.rotate3 (-90.) (0.0,0.,1.);
    glMapObj#draw_all ();

    GlMat.pop();
    Gl.enable `fog
  initializer
    glMapObj#init 2 0.;
   

end



